/* @clake/react-bootstrap4-window v0.3.4 | by Clake
 * Copyright (c) 2020 Clake,
 * 2020-03-27T00:15:45+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _bind = _interopRequireDefault(require("classnames/bind"));

require("./css/CTableInput.less");

var _reactBootstrap = require("@clake/react-bootstrap4");

var _WCombo = _interopRequireDefault(require("./WCombo"));

var _WCalendar = _interopRequireDefault(require("./WCalendar"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal["default"].signature : function (a) {
  return a;
};

var CTableInput =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CTableInput, _React$Component);

  function CTableInput(props) {
    var _this;

    _classCallCheck(this, CTableInput);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CTableInput).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "changeHandler", function (e) {
      _this.setState({
        value: e.target.value
      }); // console.log(e.target,e.currentTarget)


      if (typeof _this.props.onChange === 'function') {
        _this.props.onChange(e, e.target.value);
      }

      if (_this.combo) {
        _this.combo.filter(e.target.value);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "selectHandler", function (val, row, e) {
      _this.setState({
        value: val
      });

      if (typeof _this.props.onChange === 'function') {
        _this.props.onChange(e, val);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "calendarSelectHandler", function (val, e) {
      _this.setState({
        value: val
      });

      if (typeof _this.props.onChange === 'function') {
        _this.props.onChange(e, val);
      }
    });

    _this.state = {
      value: _this.props.data || '',
      comboData: _this.props.comboData
    };
    return _this;
  }

  _createClass(CTableInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      if (this.props.calendar) {
        this.input.addEventListener('focus', function (e) {
          _this2.calendar.show(e);
        }, false);
        this.input.addEventListener('mousedown', function (e) {
          e.stopPropagation();
        }, false);
      }

      if (this.props.combo) {
        this.input.addEventListener('focus', function (e) {
          _this2.combo.show(_this2.state.value, e);
        }, false);
        this.input.addEventListener('mousedown', function (e) {
          e.stopPropagation();
        }, false);
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        value: nextProps.data || '',
        comboData: nextProps.comboData
      });
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (nextProps.comboData !== this.props.comboData) {
        return true;
      }

      if (nextProps.disabled !== this.props.disabled) {
        return true;
      }

      return nextState.value !== this.state.value;
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-ctable-input';
      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var inputStyle = {};

      if (this.props.align) {
        inputStyle.textAlign = this.props.align;
      }

      var inputClasses = '';

      if (this.props.combo || this.props.calendar) {
        inputClasses = 'right-icon';
      }

      return _react["default"].createElement("div", {
        className: this.getClasses()
      }, _react["default"].createElement("input", _extends({
        ref: function ref(c) {
          return _this3.input = c;
        },
        type: "text"
      }, this.props, {
        onChange: this.changeHandler,
        disabled: this.props.disabled,
        style: inputStyle,
        className: inputClasses,
        value: this.state.value
      })), this.renderCombo(), this.renderCalendar());
    }
  }, {
    key: "renderCombo",
    value: function renderCombo() {
      var _this4 = this;

      if (!this.props.combo) {
        return null;
      }

      var input_icon = 'ck-wcombo-icon';
      return _react["default"].createElement("div", {
        className: "ck-input-calendar"
      }, _react["default"].createElement(_WCombo["default"], {
        ref: function ref(c) {
          return _this4.combo = c;
        },
        combo: this.props.combo,
        data: this.state.comboData,
        noSearch: this.props.readOnly,
        onSelect: this.selectHandler
      }), _react["default"].createElement("div", {
        className: input_icon,
        onClick: function onClick() {
          _this4.input.focus();
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        icon: "angle-down"
      })));
    }
  }, {
    key: "renderCalendar",
    value: function renderCalendar() {
      var _this5 = this;

      if (!this.props.calendar) {
        return null;
      }

      var input_icon = 'ck-wcalendar-icon';
      return _react["default"].createElement("div", {
        className: "ck-input-calendar"
      }, _react["default"].createElement(_WCalendar["default"], {
        ref: function ref(c) {
          return _this5.calendar = c;
        },
        onSelect: this.calendarSelectHandler,
        value: this.state.value,
        format: this.props.calendarFormat
      }), _react["default"].createElement("div", {
        className: input_icon,
        onClick: function onClick() {
          _this5.input.focus();
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        iconType: "regular",
        icon: "calendar-alt"
      })));
    }
  }, {
    key: "__reactstandin__regenerateByEval",
    // @ts-ignore
    value: function __reactstandin__regenerateByEval(key, code) {
      // @ts-ignore
      this[key] = eval(code);
    }
  }]);

  return CTableInput;
}(_react["default"].Component);

CTableInput.propTypes = {
  data: _propTypes["default"].any,
  align: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  combo: _propTypes["default"].object,
  comboData: _propTypes["default"].any,
  calendar: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  onSelect: _propTypes["default"].func
};
CTableInput.defaultProps = {};
var _default = CTableInput;
var _default2 = _default;
exports["default"] = _default2;
;

(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(CTableInput, "CTableInput", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/CTableInput.js");
  reactHotLoader.register(_default, "default", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/CTableInput.js");
})();

;

(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
//# sourceMappingURL=CTableInput.js.map
