/* @clake/react-bootstrap4-window v0.3.4 | by Clake
 * Copyright (c) 2020 Clake,
 * 2020-03-27T00:15:45+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireWildcard(require("prop-types"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _reactBootstrap = require("@clake/react-bootstrap4");

require("./css/CTable.less");

var _Drag = _interopRequireDefault(require("./Drag"));

var _CTableInput = _interopRequireDefault(require("./CTableInput"));

var _CTable2 = _interopRequireDefault(require("./i18n/CTable"));

var _PageBar = _interopRequireDefault(require("./PageBar"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal["default"].signature : function (a) {
  return a;
};

var CTable =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CTable, _React$Component);

  function CTable(props) {
    var _this;

    _classCallCheck(this, CTable);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CTable).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "sortHandler", function (e) {
      var dom = e.currentTarget;
      var sort_type = dom.dataset.sort || 'asc';

      _this.changeSort(dom, sort_type);
    });

    _defineProperty(_assertThisInitialized(_this), "scrollHandler", function (e) {
      _this.tableHeader.style.transform = "translateX(-".concat(e.currentTarget.scrollLeft, "px)"); // this.tableHeader.scrollLeft = e.currentTarget.scrollLeft;

      if (_this.tableTotal) {
        // this.tableTotal.scrollLeft = e.currentTarget.scrollLeft;
        _this.tableTotal.style.transform = "translateX(-".concat(e.currentTarget.scrollLeft, "px)");
      }
    });

    _defineProperty(_assertThisInitialized(_this), "menuContextHandler", function (e) {
      e.preventDefault();
      e.stopPropagation();
      var data = {
        field: e.currentTarget.dataset.field || '',
        data: _this.state.data[e.currentTarget.dataset.row],
        index: e.currentTarget.dataset.row
      };

      _this.mainMenu.show({
        evt: e,
        type: 'mouse',
        data: data
      });
    });

    _defineProperty(_assertThisInitialized(_this), "menuClickHandler", function (field, data) {
      switch (field) {
        case "asc":
          _this.changeSort(document.querySelector("#".concat(_this.domId, "-sort-").concat(data.field)), 'asc');

          break;

        case "desc":
          _this.changeSort(document.querySelector("#".concat(_this.domId, "-sort-").concat(data.field)), 'desc');

          break;

        case "delete_row":
          _this.deleteRowHandler(parseInt(_this.mainMenu.data.index));

          break;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "selectPageHandler", function (page) {
      if (typeof _this.props.onSelectPage === 'function') {
        _this.props.onSelectPage(page);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "addNewHandler", function (e) {
      var data = _this.state.data.slice(0);

      data.push(Object.assign({}, _this.cacheRow));

      _this.editRows.push(data.length - 1);

      _this.setState({
        data: data
      }, function () {
        document.querySelector("#".concat(_this.domId, "-edit")).previousElementSibling.querySelector('input:not([disabled])').focus();
      });
    });

    _defineProperty(_assertThisInitialized(_this), "editHandler", function (e, val) {
      var index = parseInt(e.target.dataset.row);
      var field = e.target.dataset.field;

      if (_this.editRows.indexOf(index) === -1) {
        _this.editRows.push(index);

        var data = _this.state.data.slice(0);

        data[index][field] = val;

        _this.setState({
          data: data
        });
      } else {
        _this.state.data[index][field] = val;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "selectAll", function (checked) {
      _this.select_all = checked;

      _reactBootstrap.Common.map(_this.refs, function (item, key, idx) {
        item.setChecked(_this.select_all);

        _this.setRowCheck(_this.select_all, idx);
      });
    });

    _this.state = {
      data: _this.props.data || [],
      dataCount: _this.props.dataCount,
      page: 1,
      select: _this.props.select,
      total: _this.props.total,
      filter: {
        start: '',
        end: '',
        contain: ''
      }
    };
    _this.originalData = _this.state.data.slice(0);
    _this.domId = 'table-' + _reactBootstrap.Common.RandomString(16);
    _this.select_all = false;
    _this.selectRows = [];
    _this.headerSplits = [];
    _this.sortList = {};
    _this.is_sort = typeof _this.props.onSort === 'function' || _this.props.sort;
    _this.is_filter = typeof _this.props.onFilter === 'function' || _this.props.filter;
    _this.current_sort = null;
    _this.filter_list = [];
    _this.editRows = [];

    _this.initTableWidth();

    _this.cacheRow = {};
    _this.lockColumns = []; //lock column flag

    _this.isLock = false;
    return _this;
  }

  _createClass(CTable, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.bindSplit();
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (this.state.data !== nextProps.data) {
        this.select_all = false;
        this.selectRows = [];

        if (this.props.edit) {
          this.editRows = [];
          this.originalData = _reactBootstrap.Common.Clone(nextProps.data);
        }

        if (this.allchk) {
          this.allchk.setHalf(false);
          this.selectRows = [];
        }

        this.setState({
          data: nextProps.data,
          dataCount: nextProps.dataCount,
          page: nextProps.page
        });
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (this.state.filter !== nextState.filter) {
        return true;
      }

      return nextState.data !== this.state.data;
    }
  }, {
    key: "initTableWidth",
    value: function initTableWidth() {
      var _this2 = this;

      if (this.props.width) {
        this.width = 0;
        var reg = /(\d+)(px|rem|cm|mm|pt)$/;
        var matchs = this.props.width.match(reg);
        var unit = matchs[2];

        _react["default"].Children.map(this.props.children, function (item, key) {
          if (item.props.width) {
            var _matchs = item.props.width.match(reg);

            _this2.width += parseInt(_matchs[1]);
          }
        });

        if (this.props.select) {
          this.width += 20;
        }

        this.width += unit;
      }
    } //inner source ********************

  }, {
    key: "sourceLoad",
    value: function sourceLoad() {
      var _this3 = this;

      if (typeof this.props.sourceFunc !== 'function') return;
      this.props.sourceFunc({
        source: this.props.source,
        page: this.state.page,
        number: this.props.showNumbers
      }, function (res) {
        _this3.setState({
          data: res.data,
          dataCount: res.count,
          page: res.page
        });
      });
    }
  }, {
    key: "sourceFilter",
    value: function sourceFilter() {
      var _this4 = this;

      return this.filter_list.map(function (item) {
        switch (item.type) {
          case "start":
            return {
              field: item.field,
              value: "".concat(item.text, "%"),
              flag: 'like'
            };

          case "end":
            return {
              field: item.field,
              value: "%".concat(item.text),
              flag: 'like'
            };

          case "clear":
            _this4.filter = [];
            break;

          default:
            return {
              field: item.field,
              value: "%".concat(item.text, "%"),
              flag: 'like'
            };
        }
      });
    }
  }, {
    key: "sourceOrder",
    value: function sourceOrder() {} //innter source end ***************************
    //checkbox handler

  }, {
    key: "changeHandler",
    value: function changeHandler(row, i) {
      var _this5 = this;

      return function (checked, e) {
        _this5.setRowCheck(checked, i);

        _this5.checkAllCheckHalf();

        if (typeof _this5.props.onCheck === "function") {
          _this5.props.onCheck(e.target.checked, row);
        }
      };
    }
  }, {
    key: "checkAllCheckHalf",
    value: function checkAllCheckHalf() {
      if (this.selectRows.length > 0 && this.selectRows.length !== this.state.data.length) {
        this.allchk.setHalf(true);
      }

      if (this.selectRows.length === 0) {
        this.allchk.setHalf(false);
        this.allchk.setChecked(false);
      } else if (this.selectRows.length === this.state.data.length) {
        this.allchk.setHalf(false);
        this.allchk.setChecked(true);
      }
    }
  }, {
    key: "setRowCheck",
    value: function setRowCheck(checked, rowIdx) {
      if (checked) {
        if (this.selectRows.indexOf(rowIdx) === -1) {
          this.selectRows.push(rowIdx);
        } // this.selectRows[rowIdx] = this.state.data[rowIdx];

      } else {
        if (this.selectRows.indexOf(rowIdx) !== -1) {
          this.selectRows.splice(this.selectRows.indexOf(rowIdx), 1);
        }
      }

      var row = this.refs['row_' + rowIdx];

      if (checked) {
        ReactDOM.findDOMNode(row).parentNode.parentNode.classList.add('ck-table-selected');
      } else {
        ReactDOM.findDOMNode(row).parentNode.parentNode.classList.remove('ck-table-selected');
      }
    }
  }, {
    key: "clickHandler",
    value: function clickHandler(row, i) {
      var _this6 = this;

      return function () {
        if (typeof _this6.props.onClick === 'function') {
          _this6.props.onClick(row, i);
        }
      };
    }
    /**
     * sort
     */

  }, {
    key: "changeSort",
    value: function changeSort(dom, sort_type) {
      if (!dom) {
        return;
      }

      this.clearSort(false);
      this.current_sort = dom.dataset.field;
      dom.dataset.sort = sort_type === 'asc' ? 'desc' : 'asc';
      dom.classList.remove('ck-ctable-sort');
      this.sortList[dom.dataset.field] = sort_type;
      var child = dom.querySelector('i');
      child.classList.remove('fa-sort', 'fa-sort-alpha-up', 'fa-sort-alpha-down');
      child.classList.add('fa-sort-alpha-' + (sort_type === 'asc' ? 'down' : 'up'));

      if (typeof this.props.onSort === 'function') {
        this.props.onSort(dom.dataset.field, sort_type);
      } else {// this.localSort(dom.dataset.field,sort_type)
      }
    }
  }, {
    key: "clearSort",
    value: function clearSort(emitEvt) {
      if (this.current_sort) {
        var prv = document.querySelector("#".concat(this.domId, "-sort-").concat(this.current_sort));
        prv.dataset.sort = 'asc';
        prv.classList.add('ck-ctable-sort');
        var prv_child = prv.querySelector('i');
        prv_child.classList.remove('fa-sort', 'fa-sort-alpha-up', 'fa-sort-alpha-down');
        prv_child.classList.add('fa-sort');
        this.sortList[this.current_sort] = null;
        this.current_sort = null;

        if (emitEvt && typeof this.props.onSort === 'function') {
          this.props.onSort('', 'clear');
        } else {
          this.setState({
            data: this.originalData.slice(0)
          });
        }

        return true;
      }

      return false;
    }
  }, {
    key: "localSort",
    value: function localSort(field, sort_type) {
      var desc = sort_type === 'desc';
      var data = this.state.data.slice(0);
      data.sort(function (a, b) {
        if (a[field] > b[field]) return desc ? -1 : 1;
        if (a[field] < b[field]) return desc ? 1 : -1;
        if (a[field] === b[field]) return 0;
      });
      this.setState({
        data: data
      });
    }
    /**
     * scroll header and total foot
     * @param e
     */

  }, {
    key: "localFilter",

    /**
     * filter
     * */
    value: function localFilter(text, field, type) {
      var reg;

      switch (type) {
        case "start":
          reg = new RegExp("^".concat(text));
          break;

        case "end":
          reg = new RegExp("".concat(text, "$"));
          break;

        default:
          reg = new RegExp("".concat(text));
      }

      var data = this.state.data.slice(0);
      var filter = [];
      data.forEach(function (item) {
        if (type === 'exclude') {
          if (!reg.test(item[field])) {
            filter.push(item);
          }
        } else {
          if (reg.test(item[field])) {
            filter.push(item);
          }
        }
      });
      this.setState({
        data: filter
      });
    }
  }, {
    key: "filterHandler",
    value: function filterHandler(text, field, type) {
      this.filter_list.push({
        text: text,
        field: field,
        type: type
      });
      this.setState({
        filter: {
          start: '',
          end: '',
          contain: ''
        }
      });
      this.mainMenu.hide();

      if (typeof this.props.onFilter === 'function') {
        this.props.onFilter(text, field, type);
      } else {
        this.localFilter(text, field, type);
      }
    }
  }, {
    key: "clearFilter",
    value: function clearFilter() {
      this.filter_list = [];
      var is_clean = this.clearSort(true);
      this.setState({
        filter: {
          start: '',
          end: '',
          contain: ''
        }
      });

      if (typeof this.props.onFilter === 'function') {
        this.props.onFilter('', '', 'clear');
      } else {
        if (!is_clean) {
          this.setState({
            data: this.originalData.slice(0)
          });
        }
      }
    }
  }, {
    key: "filterChangeHandler",
    value: function filterChangeHandler(field) {
      var _this7 = this;

      return function (val) {
        var filter = _this7.state.filter;
        filter[field] = val;

        _this7.setState({
          filter: filter
        });
      };
    }
  }, {
    key: "getEditRows",
    value: function getEditRows() {
      var list = [];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.editRows[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var row = _step.value;
          list.push(this.state.data[row]);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return list;
    }
  }, {
    key: "deleteRowHandler",
    value: function deleteRowHandler(row_index) {
      if (row_index < 0 || row_index >= this.state.data.length) {
        return;
      }

      if (typeof this.props.onDelete === 'function') {
        this.props.onDelete(this.state.data[row_index], row_index);
      } else {
        this.deleteRow(row_index);
      }
    }
  }, {
    key: "deleteRow",
    value: function deleteRow(row_index) {
      var _this8 = this;

      if (row_index < 0 || row_index >= this.state.data.length) {
        return;
      }

      var data = this.state.data.slice(0);
      data.splice(row_index, 1);

      if (this.editRows.indexOf(row_index) !== -1) {
        this.editRows.splice(this.editRows.indexOf(row_index), 1);
      }

      this.editRows.forEach(function (item, index) {
        if (item > row_index) {
          _this8.editRows[index] = item - 1;
        }
      });
      this.setState({
        data: data
      });
    } //****************************

  }, {
    key: "getSelectRows",

    /**
     * 得到所有选中的行
     * @returns {*}
     */
    value: function getSelectRows() {
      var _this9 = this;

      return this.selectRows.map(function (item) {
        return _this9.state.data[item];
      });
    }
    /**
     * 设置选中的行
     * @param key 对应行数据的KEY值
     * @param list 要选中的数据值
     */

  }, {
    key: "setSelectRows",
    value: function setSelectRows(key, list) {
      var _this10 = this;

      this.state.data.forEach(function (row, i) {
        if (list.indexOf(row[key]) !== -1) {
          _this10.refs['row_' + i].setChecked(true);

          _this10.setRowCheck(true, i);
        } else {
          _this10.refs['row_' + i].setChecked(false);

          _this10.setRowCheck(false, i);
        }
      });
      this.checkAllCheckHalf();
    }
    /**
     * binding column split
     */

  }, {
    key: "bindSplit",
    value: function bindSplit() {
      var _this11 = this;

      if (this.props.move) {
        this.headerSplits.forEach(function (split) {
          if (!_this11.drag) {
            _this11.dragColumnLeft = 0;
            _this11.dragWidth = 0;
            _this11.drag = new _Drag["default"](_this11.split, split, {
              start: function start(dragDom, eventDom) {
                var xy = _reactBootstrap.Common.GetDomXY(eventDom, _this11.mainDom);

                _this11.dragWidth = parseInt(eventDom.parentNode.style.width);
                _this11.dragColumnLeft = xy.left - _this11.table_rows.scrollLeft;
                dragDom.style.left = _this11.dragColumnLeft + 'px';
                dragDom.classList.remove('d-none');
                return true;
              },
              move: function move(_move, dragDom, eventDom) {
                if (_this11.dragWidth + (_move.x - _this11.dragColumnLeft) < 50) {
                  _move.x = _this11.dragColumnLeft - _this11.dragWidth + 50;
                }
              },
              end: function end(dragDom, eventDom) {
                dragDom.classList.add('d-none');
                var column_key = eventDom.dataset.key;

                var diff = parseInt(dragDom.style.left) - _this11.dragColumnLeft;

                _this11.width = parseInt(_this11.width) + diff + 'px';
                _this11.table_head.style.width = _this11.width;
                _this11.table_body.style.width = _this11.width;

                if (_this11.table_total) {
                  _this11.table_total.style.width = _this11.width;
                }

                document.querySelectorAll("#".concat(column_key)).forEach(function (item) {
                  item.style.width = "".concat(_this11.dragWidth + diff, "px");
                });
                return true;
              }
            });
          } else {
            _this11.drag.setEventDom(split);
          }
        });
      }
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'table ck-table'; //striped

      if (this.props.striped && !this.props.edit) {
        base = (0, _bind["default"])(base, 'table-striped');
      } //theme


      if (this.props.theme) {
        base = (0, _bind["default"])(base, 'table-' + this.props.theme);
      } //bordered


      if (this.props.bordered) {
        base = (0, _bind["default"])(base, 'table-bordered');
      } //hover


      if (this.props.hover) {
        base = (0, _bind["default"])(base, 'table-hover');
      } //sm


      if (this.props.sm) {
        base = (0, _bind["default"])(base, 'table-sm');
      }

      if (this.props.fontSm) {
        base = (0, _bind["default"])(base, 'table-font-sm');
      } //responsive


      if (this.props.responsive) {
        base = (0, _bind["default"])(base, 'table-responsive');
      } //nowrap


      if (this.props.noWrap && !this.props.edit) {
        base = (0, _bind["default"])(base, 'ck-ctable-nowrap');
      }

      return base;
    }
  }, {
    key: "getMainClasses",
    value: function getMainClasses() {
      var base = 'ck-ctable-main d-flex flex-column';

      if (this.props.bordered) {
        base = (0, _bind["default"])(base, 'border');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getStyles",
    value: function getStyles() {
      //default style
      var base = {}; //width

      if (this.props.width) {
        base.width = this.props.width;
      } //height


      if (this.props.height) {
        base.height = this.props.height;
      }

      if (this.props.absolute) {
        base.position = 'absolute';
        base.top = this.props.y;
        base.left = this.props.x;

        if (_typeof(this.props.position) === 'object') {
          base.top = this.props.position.top || this.props.y;
          base.left = this.props.position.left || this.props.x;
          base.right = this.props.position.right || 'unset';
          base.bottom = this.props.position.bottom || 'unset';

          if (this.props.position.left && this.props.position.right) {
            base.width = 'unset';
          }

          if (this.props.position.top && this.props.position.bottom) {
            base.height = 'unset';
          }
        }
      }

      return _reactBootstrap.Common.extend(base, this.props.style);
    }
  }, {
    key: "getHeaderClasses",
    value: function getHeaderClasses() {
      var base = 'ck-ctable-header';

      if (this.props.headerTheme) {
        base = (0, _bind["default"])(base, 'thead-' + this.props.headerTheme);
      }

      return (0, _bind["default"])(base, this.props.headClass);
    }
  }, {
    key: "getTableStyles",
    value: function getTableStyles(style) {
      var base = {};

      if (this.width) {
        base.width = this.width;
      }

      if (style) {
        base = Object.assign({}, base, style);
      }

      return base;
    }
  }, {
    key: "getBodyClasses",
    value: function getBodyClasses() {
      var base = 'ck-ctable-body flex-grow-1 d-flex flex-column';
      return base;
    }
  }, {
    key: "render",
    value: function render() {
      var _this12 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this12.mainDom = c;
        },
        className: this.getMainClasses(),
        style: this.getStyles()
      }, _react["default"].createElement("div", {
        className: this.getBodyClasses()
      }, this.renderHeader(), this.renderRows(), this.renderTotal(), _react["default"].createElement(_reactBootstrap.Scroll, {
        selector: "#table-body-com-".concat(this.domId)
      }), _react["default"].createElement(_reactBootstrap.HScroll, {
        selector: "#table-body-com-".concat(this.domId)
      })), this.renderFoot(), _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this12.split = c;
        },
        className: "ck-split d-none"
      }));
    }
  }, {
    key: "renderHeader",
    value: function renderHeader() {
      var _this13 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this13.tableHeader = c;
        }
      }, _react["default"].createElement("table", {
        ref: function ref(c) {
          return _this13.table_head = c;
        },
        id: "table-head-".concat(this.domId),
        className: this.getClasses(),
        style: this.getTableStyles()
      }, _react["default"].createElement("thead", {
        className: this.getHeaderClasses()
      }, _react["default"].createElement("tr", null, this.state.select ? _react["default"].createElement("th", {
        style: {
          width: '20px',
          textAlign: 'center'
        }
      }, this.props.edit ? _react["default"].createElement(_reactBootstrap.Icon, {
        icon: "list"
      }) : _react["default"].createElement(_reactBootstrap.CCheckbox, {
        ref: function ref(c) {
          return _this13.allchk = c;
        },
        onChange: this.selectAll
      })) : null, _react["default"].Children.map(this.props.children, function (item, key) {
        _this13.cacheRow[item.props.field] = '';

        if (!item || item.props.hide) {
          return null;
        } // let align = item.props.align || this.props.align;


        var style = {
          'textAlign': 'center'
        };

        if (item.props.width) {
          style.width = item.props.width;
        }

        var sort_icon = 'sort';

        if (_this13.sortList[item.props.field]) {
          sort_icon = 'sort-alpha-' + (_this13.sortList[item.props.field] === 'asc' ? 'down' : 'up');
        }

        return _react["default"].createElement("th", {
          onContextMenu: _this13.menuContextHandler,
          id: _this13.domId + '-' + key,
          "data-key": 'head_' + key,
          style: style
        }, _this13.is_sort ? _react["default"].createElement("a", {
          className: "ck-ctable-sort",
          href: "javascript://",
          id: "".concat(_this13.domId, "-sort-").concat(item.props.field),
          "data-field": item.props.field,
          onClick: _this13.sortHandler
        }, item.props.text, " ", _react["default"].createElement(_reactBootstrap.Icon, {
          icon: sort_icon
        })) : item.props.text, _this13.props.move ? _react["default"].createElement("span", {
          ref: function ref(c) {
            return _this13.headerSplits.push(c);
          },
          "data-key": _this13.domId + '-' + key,
          className: "ck-column-split"
        }) : null);
      })))));
    }
  }, {
    key: "renderRows",
    value: function renderRows() {
      var _this14 = this;

      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this14.table_rows = c;
        },
        id: "table-body-com-".concat(this.domId),
        className: "flex-grow-1 rows",
        onScroll: this.scrollHandler
      }, _react["default"].createElement("table", {
        ref: function ref(c) {
          return _this14.table_body = c;
        },
        id: "table-body-".concat(this.domId),
        className: this.getClasses(),
        style: this.getTableStyles()
      }, _react["default"].createElement("tbody", null, this.state.data.map(function (row, i) {
        if (_this14.props.edit) {
          return _this14.renderEditRow(row, i);
        }

        return _this14.renderRow(row, i);
      }), this.props.edit ? this.renderEditAddRow() : null)), this.props.menu ? this.renderMenu() : null);
    }
  }, {
    key: "renderRow",
    value: function renderRow(row, i, parentRow) {
      var _this15 = this;

      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("tr", {
        className: this.props.onClick ? 'click-row' : null,
        onClick: this.clickHandler(row, i)
      }, this.state.select ? _react["default"].createElement("th", {
        style: {
          width: '20px',
          textAlign: 'center'
        }
      }, _react["default"].createElement(_reactBootstrap.CCheckbox, {
        ref: 'row_' + i,
        onChange: this.changeHandler(row, i)
      })) : null, _react["default"].Children.map(this.props.children, function (item, key) {
        if (!item || item.props.hide) {
          return null;
        } //set style


        var style = _objectSpread({}, _this15.props.columnStyle);

        style.textAlign = item.props.align || _this15.props.align;

        if (item.props.width) {
          style.width = item.props.width;
        }

        if (item.props.children) {
          return _react["default"].createElement("td", {
            onContextMenu: _this15.menuContextHandler,
            id: _this15.domId + '-' + key,
            "data-row": "".concat(i),
            "data-field": item.props.field,
            className: item.props.className,
            style: {
              'text-align': align
            },
            key: 'col_' + key
          }, _react["default"].cloneElement(item, {
            text: item.props.text,
            row: row,
            value: row[item.props.field]
          }));
        } else {
          return _react["default"].createElement("td", {
            onContextMenu: _this15.menuContextHandler,
            id: _this15.domId + '-' + key,
            "data-field": item.props.field,
            style: style,
            onClick: function onClick(e) {
              if (typeof item.props.onClick === 'function') {
                item.props.onClick(row);
              }
            },
            onDoubleClick: function onDoubleClick(e) {
              if (typeof item.props.onDoubleClick === 'function') {
                item.props.onDoubleClick(row);
              }
            },
            "data-row": "".concat(i)
          }, item.props.onFormat ? item.props.onFormat(row[item.props.field], row, item.props.field) : row[item.props.field]);
        }
      })));
    }
  }, {
    key: "renderEditRow",
    value: function renderEditRow(row, i) {
      var _this16 = this;

      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("tr", {
        className: this.props.onClick ? 'click-row' : null,
        onClick: this.clickHandler(row, i)
      }, this.state.select ? _react["default"].createElement("th", {
        style: {
          width: '20px',
          textAlign: 'center'
        }
      }, this.editRows.indexOf(i) === -1 ? null : _react["default"].createElement(_reactBootstrap.Icon, {
        id: "".concat(this.domId, "-edit-row-icon-").concat(i),
        icon: "edit",
        className: "text-danger"
      })) : null, _react["default"].Children.map(this.props.children, function (item, key) {
        if (!item || item.props.hide) {
          return null;
        } //set style


        var style = _objectSpread({}, _this16.props.columnStyle);

        style.textAlign = item.props.align || _this16.props.align;

        if (item.props.width) {
          style.width = item.props.width;
        }

        return _react["default"].createElement("td", {
          onContextMenu: _this16.menuContextHandler,
          className: item.props.disabled ? 'disabled' : '',
          id: _this16.domId + '-' + key,
          "data-field": item.props.field,
          style: style,
          onClick: function onClick(e) {
            if (typeof item.props.onClick === 'function') {
              item.props.onClick(row);
            }
          },
          onDoubleClick: function onDoubleClick(e) {
            if (typeof item.props.onDoubleClick === 'function') {
              item.props.onDoubleClick(row);
            }
          },
          "data-row": "".concat(i)
        }, _this16.renderEditComponent(item.props, row, i));
      })));
    }
  }, {
    key: "renderEditAddRow",
    value: function renderEditAddRow() {
      var _this17 = this;

      return _react["default"].createElement("tr", {
        id: this.domId + '-edit'
      }, this.state.select ? _react["default"].createElement("th", {
        style: {
          width: '20px',
          textAlign: 'center'
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        icon: "chevron-circle-right"
      })) : null, _react["default"].Children.map(this.props.children, function (item, key) {
        if (!item || item.props.hide) {
          return null;
        }

        var style = {
          width: item.props.width
        };
        return _react["default"].createElement("td", {
          style: style
        }, _react["default"].createElement(_CTableInput["default"], {
          onFocus: _this17.addNewHandler
        }));
      }));
    }
  }, {
    key: "renderEditComponent",
    value: function renderEditComponent(item, row, i) {
      switch (item.type) {
        case "combo":
          return _react["default"].createElement(_CTableInput["default"], {
            onChange: this.editHandler,
            "data-row": i,
            "data-field": item.field,
            data: row[item.field],
            align: item.align,
            disabled: item.disabled,
            combo: item.combo,
            comboData: item.comboData
          });

        case "calendar":
          return _react["default"].createElement(_CTableInput["default"], {
            onChange: this.editHandler,
            "data-row": i,
            "data-field": item.field,
            data: row[item.field],
            align: item.align,
            disabled: item.disabled,
            calendarFormat: item.calendarFormat,
            calendar: true
          });

        case "checkbox":
          break;

        default:
          return _react["default"].createElement(_CTableInput["default"], {
            onChange: this.editHandler,
            "data-row": i,
            "data-field": item.field,
            data: row[item.field],
            align: item.align,
            disabled: item.disabled
          });
      }
    }
  }, {
    key: "renderFoot",
    value: function renderFoot() {
      if (!this.props.foot) {
        return null;
      }

      return _react["default"].createElement("div", null, _react["default"].createElement(_PageBar["default"], {
        page: this.state.page,
        dataCount: this.state.dataCount,
        onSelect: this.selectPageHandler,
        showNumbers: this.props.showNumbers,
        showPages: this.props.showPages
      }));
    }
  }, {
    key: "renderTotal",
    value: function renderTotal() {
      var _this18 = this;

      if (!this.state.total) {
        return null;
      }

      var total = this.state.total;
      return _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this18.tableTotal = c;
        }
      }, _react["default"].createElement("table", {
        ref: function ref(c) {
          return _this18.table_total = c;
        },
        id: "table-total-".concat(this.domId),
        className: this.getClasses(),
        style: this.getTableStyles()
      }, _react["default"].createElement("tbody", null, _react["default"].createElement("tr", null, this.state.select ? _react["default"].createElement("td", {
        width: "20px"
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        icon: "chart-line"
      })) : null, _react["default"].Children.map(this.props.children, function (item, key) {
        if (!item || item.props.hide) {
          return null;
        }

        var align = item.props.align || _this18.props.align;
        var style = {
          'textAlign': align
        };

        if (item.props.width) {
          style.width = item.props.width;
        }

        return _react["default"].createElement("td", {
          id: _this18.domId + '-' + key,
          "data-field": item.props.field,
          style: style
        }, item.props.onFormat ? item.props.onFormat(total[item.props.field], total, item.props.field) : total[item.props.field]);
      })))));
    }
  }, {
    key: "renderMenu",
    value: function renderMenu() {
      var _this19 = this;

      var lang = this.props.lang;

      if (!lang) {
        var i18 = _reactBootstrap.i18n.getLang();

        var langStr = typeof lang === 'string' ? lang : i18["short"];
        lang = _CTable2["default"][langStr];
      }

      return _react["default"].createElement(_reactBootstrap.Menu, {
        ref: function ref(c) {
          return _this19.mainMenu = c;
        },
        onClick: this.menuClickHandler
      }, _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "copy",
        onClick: function onClick() {
          document.execCommand("copy");
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "mr-1",
        icon: "copy"
      }), lang['Copy']), _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "cut",
        onClick: function onClick() {
          document.execCommand("cut");
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "mr-1",
        icon: "cut"
      }), lang['Cut']), this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        step: true
      }) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "select_filter",
        onClick: function onClick(e, field, data) {
          var select = document.getSelection();

          _this19.filterHandler(select.toString(), data.field, 'contain');
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "mr-1",
        icon: "filter"
      }), lang['Filter By Selection']) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "select_exclude",
        onClick: function onClick(e, field, data) {
          var select = document.getSelection();

          _this19.filterHandler(select.toString(), data.field, 'exclude');
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "mr-1",
        icon: "filter"
      }), lang['Filter Excluding Selection']) : null, this.is_filter || this.is_sort ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "clear_filter",
        onClick: function onClick() {
          _this19.clearFilter();
        }
      }, _react["default"].createElement("span", {
        className: "text-danger"
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "mr-1",
        icon: "brush"
      }), lang['Clear Filter / Sort'])) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        step: true
      }) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "filter"
      }, _react["default"].createElement("span", {
        className: "mr-1",
        style: inputStyle
      }, lang['Start With']), _react["default"].createElement(_reactBootstrap.Input, {
        className: "mr-1",
        size: "xs",
        width: "120px",
        data: this.state.filter.start,
        onChange: this.filterChangeHandler('start'),
        onMouseDown: stopEvent,
        onEnter: function onEnter() {
          _this19.filterHandler(_this19.state.filter.start, _this19.mainMenu.data.field, 'start');
        }
      }), _react["default"].createElement(_reactBootstrap.Button, {
        size: "xs",
        onMouseDown: stopEvent,
        onClick: function onClick(e) {
          _this19.filterHandler(_this19.state.filter.start, _this19.mainMenu.data.field, 'start');
        },
        icon: "search"
      })) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "filter"
      }, _react["default"].createElement("span", {
        className: "mr-1",
        style: inputStyle
      }, lang['End With']), _react["default"].createElement(_reactBootstrap.Input, {
        className: "mr-1",
        size: "xs",
        width: "120px",
        data: this.state.filter.end,
        onChange: this.filterChangeHandler('end'),
        onMouseDown: stopEvent,
        onEnter: function onEnter() {
          _this19.filterHandler(_this19.state.filter.start, _this19.mainMenu.data.field, 'end');
        }
      }), _react["default"].createElement(_reactBootstrap.Button, {
        size: "xs",
        onMouseDown: stopEvent,
        onClick: function onClick(e) {
          _this19.filterHandler(_this19.state.filter.end, _this19.mainMenu.data.field, 'end');
        },
        icon: "search"
      })) : null, this.is_filter ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "filter"
      }, _react["default"].createElement("span", {
        className: "mr-1",
        style: inputStyle
      }, lang['Contain with']), _react["default"].createElement(_reactBootstrap.Input, {
        className: "mr-1",
        size: "xs",
        width: "120px",
        data: this.state.filter.contain,
        onChange: this.filterChangeHandler('contain'),
        onMouseDown: stopEvent,
        onEnter: function onEnter() {
          _this19.filterHandler(_this19.state.filter.start, _this19.mainMenu.data.field, 'contain');
        }
      }), _react["default"].createElement(_reactBootstrap.Button, {
        size: "xs",
        onMouseDown: stopEvent,
        onClick: function onClick(e) {
          _this19.filterHandler(_this19.state.filter.contain, _this19.mainMenu.data.field, 'contain');
        },
        icon: "search"
      })) : null, this.is_sort ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        step: true
      }) : null, this.is_sort ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "asc"
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "mr-1",
        icon: "sort-alpha-down"
      }), lang['Sort Ascending']) : null, this.is_sort ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "desc"
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        className: "mr-1",
        icon: "sort-alpha-up"
      }), lang['Sort Descending']) : null, this.props.edit ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        step: true
      }) : null, this.props.edit ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        field: "delete_row"
      }, lang['Delete Row']) : null, this.props.customMenu ? _react["default"].createElement(_reactBootstrap.Menu.Item, {
        step: true
      }) : null, this.props.customMenu ? this.props.customMenu.map(function (menu) {
        return _this19.explainCustomMenu(menu);
      }) : null);
    }
  }, {
    key: "explainCustomMenu",
    value: function explainCustomMenu(menu) {
      var _this20 = this;

      if (menu.children && menu.children instanceof Array) {
        return _react["default"].createElement(_reactBootstrap.Menu.Item, {
          field: menu.field,
          text: menu.text,
          child: true
        }, menu.children.map(function (item) {
          return _this20.explainCustomMenu(item);
        }));
      } else {
        return _react["default"].createElement(_reactBootstrap.Menu.Item, {
          field: menu.field,
          onClick: menu.click
        }, menu.text);
      }
    }
  }, {
    key: "__reactstandin__regenerateByEval",
    // @ts-ignore
    value: function __reactstandin__regenerateByEval(key, code) {
      // @ts-ignore
      this[key] = eval(code);
    }
  }]);

  return CTable;
}(_react["default"].Component);

var inputStyle = {
  width: '80px'
};

var stopEvent = function stopEvent(e) {
  e.stopPropagation();
};

CTable.propTypes = {
  theme: _propTypes["default"].oneOf(['primary', 'secondary', 'success', 'danger', 'warning', 'info', 'light', 'dark']),
  headerTheme: _propTypes["default"].oneOf(['primary', 'secondary', 'success', 'danger', 'warning', 'info', 'light', 'dark']),
  headClass: _propTypes["default"].string,
  data: _propTypes["default"].array,
  dataCount: _propTypes["default"].number,
  page: _propTypes["default"].number,
  select: _propTypes["default"].bool,
  header: _propTypes["default"].bool,
  center: _propTypes["default"].bool,
  currentPage: _propTypes["default"].number,
  striped: _propTypes["default"].bool,
  bordered: _propTypes["default"].bool,
  hover: _propTypes["default"].bool,
  sm: _propTypes["default"].bool,
  fontSm: _propTypes["default"].bool,
  responsive: _propTypes["default"].bool,
  align: _propTypes["default"].string,
  tree: _propTypes["default"].string,
  onClickTree: _propTypes["default"].func,
  onClick: _propTypes["default"].func,
  onCheck: _propTypes["default"].func,
  onFilter: _propTypes["default"].func,
  onSort: _propTypes["default"].func,
  move: _propTypes["default"].bool,
  onRefresh: _propTypes["default"].func,
  refreshText: _propTypes["default"].string,
  absolute: _propTypes["default"].bool,
  x: _propTypes["default"].string,
  y: _propTypes["default"].string,
  width: _propTypes["default"].string,
  height: _propTypes["default"].string,
  // foot        : PropTypes.bool,
  foot: _propTypes["default"].objectOf(),
  position: _propTypes["default"].object,
  showPages: _propTypes["default"].number,
  showNumbers: _propTypes["default"].number,
  onSelectPage: _propTypes["default"].func,
  noWrap: _propTypes["default"].bool,
  menu: _propTypes["default"].bool,
  total: _propTypes["default"].object,
  edit: _propTypes["default"].bool,
  onDelete: _propTypes["default"].func,
  sort: _propTypes["default"].bool,
  filter: _propTypes["default"].bool,
  customMenu: _propTypes["default"].array,
  lang: _propTypes["default"].object,
  source: _propTypes["default"].string,
  sourceFunc: _propTypes["default"].func
};
CTable.defaultProps = {
  data: [],
  dataCount: 1,
  select: true,
  header: true,
  foot: true,
  currentPage: 1,
  hover: true,
  striped: true,
  align: 'left',
  sm: true,
  fontSm: true,
  headerTheme: 'light',
  noWrap: true,
  bordered: true,
  move: true,
  menu: true,
  showNumbers: 30,
  showPages: 10,
  source: null
};
var _default = CTable;
var _default2 = _default;
exports["default"] = _default2;
;

(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(CTable, "CTable", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/CTable.js");
  reactHotLoader.register(inputStyle, "inputStyle", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/CTable.js");
  reactHotLoader.register(stopEvent, "stopEvent", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/CTable.js");
  reactHotLoader.register(_default, "default", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/CTable.js");
})();

;

(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
//# sourceMappingURL=CTable.js.map
