/* @clake/react-bootstrap4-window v0.3.4 | by Clake
 * Copyright (c) 2020 Clake,
 * 2020-03-27T00:15:45+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _bind = _interopRequireDefault(require("classnames/bind"));

require("./css/PageBar.less");

var _reactBootstrap = require("@clake/react-bootstrap4");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal["default"].signature : function (a) {
  return a;
};

var PageBar =
/*#__PURE__*/
function (_React$Component) {
  _inherits(PageBar, _React$Component);

  function PageBar(props) {
    var _this;

    _classCallCheck(this, PageBar);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PageBar).call(this, props));
    _this.state = {
      page: _this.props.page,
      dataCount: _this.props.dataCount,
      pages: _this.calPage(_this.props.dataCount, _this.props.showNumbers)
    };
    return _this;
  }

  _createClass(PageBar, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps, nextContext) {
      if (nextProps !== this.props) {
        this.setState({
          page: nextProps.page,
          dataCount: nextProps.dataCount,
          pages: this.calPage(nextProps.dataCount, nextProps.showNumbers)
        });
      }
    }
  }, {
    key: "calPage",
    value: function calPage(count, number) {
      console.log(count, number);
      var pages = parseInt(count / number);

      if (count % number !== 0) {
        pages += 1;
      }

      return pages;
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-pagebar-main d-flex align-items-center';
      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "changePage",
    value: function changePage(page) {
      if (page < 1) {
        page = 1;
      }

      if (page > this.state.pages) {
        page = this.state.pages;
      }

      if (typeof this.props.onSelect === 'function') {
        this.props.onSelect(page);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("div", {
        className: this.getClasses()
      }, _react["default"].createElement("div", {
        className: "total"
      }, this.props.dataCount), _react["default"].createElement("div", {
        className: "page d-flex align-items-center align-self-center"
      }, _react["default"].createElement("div", {
        className: "icon-btn",
        onClick: function onClick() {
          _this2.changePage(_this2.state.page - 1);
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        icon: "angle-double-left"
      })), _react["default"].createElement("div", {
        className: "page-show"
      }, _react["default"].createElement("input", {
        onChange: function onChange(e) {
          _this2.setState({
            page: e.value
          });
        },
        onKeyPress: function onKeyPress(e) {
          if (e.keyCode === 13) {
            _this2.changePage(parseInt(e.value));
          }
        },
        type: "text",
        value: this.state.page
      }), " / ", this.state.pages), _react["default"].createElement("div", {
        className: "icon-btn",
        onClick: function onClick() {
          _this2.changePage(_this2.state.page + 1);
        }
      }, _react["default"].createElement(_reactBootstrap.Icon, {
        icon: "angle-double-right"
      }))));
    }
  }, {
    key: "__reactstandin__regenerateByEval",
    // @ts-ignore
    value: function __reactstandin__regenerateByEval(key, code) {
      // @ts-ignore
      this[key] = eval(code);
    }
  }]);

  return PageBar;
}(_react["default"].Component);

PageBar.propTypes = {
  dataCount: _propTypes["default"].number,
  page: _propTypes["default"].number,
  showNumbers: _propTypes["default"].number,
  showPages: _propTypes["default"].number,
  onSelect: _propTypes["default"].func
};
PageBar.defaultProps = {};
var _default = PageBar;
var _default2 = _default;
exports["default"] = _default2;
;

(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(PageBar, "PageBar", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/PageBar.js");
  reactHotLoader.register(_default, "default", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/PageBar.js");
})();

;

(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
//# sourceMappingURL=PageBar.js.map
