/* @clake/react-bootstrap4-window v0.3.4 | by Clake
 * Copyright (c) 2020 Clake,
 * 2020-03-27T00:15:45+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var ReactDOM = _interopRequireWildcard(require("react-dom"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _reactBootstrap = require("@clake/react-bootstrap4");

require("./css/WCombo.less");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

(function () {
  var enterModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.enterModule : undefined;
  enterModule && enterModule(module);
})();

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var __signature__ = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal["default"].signature : function (a) {
  return a;
};

var WCombo =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(WCombo, _React$PureComponent);

  function WCombo(props) {
    var _this;

    _classCallCheck(this, WCombo);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(WCombo).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "hide", function () {
      _this.dom.classList.add('d-none');
    });

    _defineProperty(_assertThisInitialized(_this), "selectHandler", function (val, row) {
      if (typeof _this.props.onSelect === 'function') {
        _this.props.onSelect(val, row, _this.event);
      }
    });

    _this.event = null;
    _this.calDom = null;
    return _this;
  }

  _createClass(WCombo, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.calDom = ReactDOM.findDOMNode(this.combo);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('mousedown', this.hide, false);
    }
  }, {
    key: "show",
    value: function show(search, e) {
      var xy = _reactBootstrap.Common.GetDomXY(e.currentTarget); // let fixed = this.calculatePosition(e.currentTarget);
      // console.log(fixed);


      var positionTop = xy.top + xy.height;
      this.dom.style.left = xy.left + 'px';
      this.dom.classList.remove('d-none');
      this.event = e;
      this.combo.show(search, e.currentTarget);

      if (positionTop + this.calDom.offsetHeight > document.documentElement.scrollTop + document.documentElement.clientHeight) {} else {
        positionTop += 5;
      }

      this.dom.style.top = positionTop + 'px';
    }
  }, {
    key: "filter",
    value: function filter(val) {
      this.combo.filter(val);
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-wcombo d-none';
      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var content = _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this2.dom = c;
        },
        className: this.getClasses()
      }, _react["default"].createElement(_reactBootstrap.Combo, _extends({
        ref: function ref(c) {
          return _this2.combo = c;
        }
      }, this.props.combo, {
        sm: true,
        data: this.props.data,
        noSearch: this.props.noSearch,
        onSelect: this.selectHandler,
        onClose: this.hide
      })));

      var mainDom = document.getElementById('wcombo');

      if (!mainDom) {
        mainDom = document.createElement("DIV");
        mainDom.id = 'wcombo';
        mainDom.className = 'ck-wcombo-container';
        document.body.appendChild(mainDom);
      }

      return ReactDOM.createPortal(content, mainDom);
    }
  }, {
    key: "__reactstandin__regenerateByEval",
    // @ts-ignore
    value: function __reactstandin__regenerateByEval(key, code) {
      // @ts-ignore
      this[key] = eval(code);
    }
  }]);

  return WCombo;
}(_react["default"].PureComponent);

WCombo.propTypes = {};
WCombo.defaultProps = {};
var _default = WCombo;
var _default2 = _default;
exports["default"] = _default2;
;

(function () {
  var reactHotLoader = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.default : undefined;

  if (!reactHotLoader) {
    return;
  }

  reactHotLoader.register(WCombo, "WCombo", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/WCombo.js");
  reactHotLoader.register(_default, "default", "/Users/clakeboy/Documents/git_project/react-bootstrap-v4-window/src/WCombo.js");
})();

;

(function () {
  var leaveModule = typeof reactHotLoaderGlobal !== 'undefined' ? reactHotLoaderGlobal.leaveModule : undefined;
  leaveModule && leaveModule(module);
})();
//# sourceMappingURL=WCombo.js.map
